// placeholders / mergetags for SuperWebMailer/SuperMailingList 2023 mirko boeer

          function GetAllDefinedSWMSMLPlaceholders(editor, IgnoreField){
            let p_array = Array();

            var result = [];

            if(typeof arrPlaceholderItems !== 'undefined')
              p_array = p_array.concat(arrPlaceholderItems);

            if(typeof arrSubscribePlaceholders !== 'undefined' && (editor.name == 'OptInConfirmationMailHTMLText'))
              p_array = p_array.concat(arrSubscribePlaceholders);

            if(typeof arrUnsubscribePlaceholders !== 'undefined' && (editor.name == 'OptOutConfirmationMailHTMLText'))
              p_array = p_array.concat(arrUnsubscribePlaceholders);

            if(typeof arrNewsletterUnsubscribePlaceholders !== 'undefined' && (editor.name == 'OptInConfirmedMailHTMLText' || editor.name == 'MailHTMLText' || editor.name == 'multiline'))
              p_array = p_array.concat(arrNewsletterUnsubscribePlaceholders);

            if(typeof arrEditPlaceholders !== 'undefined' && (editor.name == 'EditConfirmationMailHTMLText'))
              p_array = p_array.concat(arrEditPlaceholders);

            if(typeof arrResponderPlaceholders !== 'undefined')
              p_array = p_array.concat(arrResponderPlaceholders);

            if(typeof IgnoreField === "string")
              for(var i=p_array.length - 1; i > -1; i--)
                if(p_array[i][0].indexOf(IgnoreField) > -1)
                  p_array.splice(i, 1);

            return p_array;
          }

tinymce.PluginManager.add('placeholders', (editor, url) => {


     pluginHTMLEntityDecode = function(string) {
         var ret, tarea = document.createElement('textarea');
         tarea.innerHTML = string;
         ret = tarea.value;
         tarea = null;
         return ret;
     }

    editor.ui.registry.addIcon('placeholder', DownloadFile(tinymce.defaulteditorConfig.baseMyPluginsUrl + 'placeholders/placeholder.svg'));

    editor.ui.registry.addMenuButton('placeholdersbutton', {
      //text: pluginHTMLEntityDecode( editor.options.get("language") == "de" ? "Platzhalter..." : "Placeholders..." ),
      tooltip: pluginHTMLEntityDecode( editor.options.get("language") == "de" ? "Platzhalter einf&uuml;gen" : "Insert placeholder" ),
      icon: "placeholder",

      onSetup: aMenuButton=>{
          const isEditable = ()=>{
              var sel = editor.selection.getStart();
              var notAllowedTags = ["IMG", "TABLE", "TR", "HR", "OBJECT", "EMBED"];
              aMenuButton.setEnabled( editor.selection.isEditable() && !notAllowedTags.includes(sel.tagName)  );
          };
          return editor.on("NodeChange", isEditable),
          isEditable(),
          ()=>{
              editor.off("NodeChange", isEditable)
          }
      },

      fetch: function (callback) {
        callback(GetMenuItems());
      }
    });


   function GetMenuItems(){
      var items = [];
      let PlaceholderItems = GetAllDefinedSWMSMLPlaceholders(editor);
      for(var i=0; i<PlaceholderItems.length; i++){

        const value = pluginHTMLEntityDecode( PlaceholderItems[i][0] );
        var a = function () {
             // editor.insertContent( '<span class="mce-mergetag" contenteditable="false" data-mce-cef-wrappable="true" data-mce-mergetag="1">' + value + '</span> ' );
              if(value.indexOf('Link') == -1)
                editor.insertContent(value);
                else{
                  var content = editor.selection.getContent();
                  editor.insertContent( '<a href="' + value + '" target="_blank">' + content + '</a>' );
                }
            }

        var item =
          {
            type: 'menuitem',
            text: pluginHTMLEntityDecode( PlaceholderItems[i][1] ),
            icon: "placeholder",
            tooltip: value,
            onAction: a
          };
        items.push(item);
      }
      return items;
   }

  editor.ui.registry.addNestedMenuItem('mnuPlaceholders', {
    text: pluginHTMLEntityDecode( editor.options.get("language") == "de" ? "Platzhalter einf&uuml;gen" : "Placeholders" ),
    icon: "placeholder",
    onSetup: aMenuButton=>{
        const isEditable = ()=>{
            var sel = editor.selection.getStart();
            var notAllowedTags = ["IMG", "TABLE", "TR", "HR", "OBJECT", "EMBED"];
            aMenuButton.setEnabled( editor.selection.isEditable() && !notAllowedTags.includes(sel.tagName)  );
        };
        return editor.on("NodeChange", isEditable),
        isEditable(),
        ()=>{
            editor.off("NodeChange", isEditable)
        }
    },
    getSubmenuItems: () => GetMenuItems()
  });

  return {
    name: 'PlaceholdersPlugin',
    url: 'https://www.superwebmailer.de/'
  };

});

